  //----------------------------------------------------------------------------------
//    Multi Band DDS VFO Ver3.1        
//                         JA2NKD 2016.10.19 
//                         JA2GQP 2016/10/23
//    MOD by OZ6YK                2020.01.05 To 10 band trx 1 to 30 MHz
//
//     Aruduino IDE 1.8.2
//     Arduino UNO
//     
// <Rotary.h>    https://github.com/brianlow/Rotary
// 
// "Ucglib.h"    https://github.com/olikraus/ucglib
// "si5351ajk.h"   https://kuepper.dk/?page_id=129
// Before installing this file, install the vfo_jk_eep.ino file.
// Else you will not have the 10 bands, but onely 1 band.
//---------------------------------------------------------------------------------
// si5351a transplant  2016/10/23  JA2GQP
//       (si5351a.h is original hedder file.)
//  now si5351ajk.h because of the use of BFO
//---------------------------------------------------------------------------------

//---------- Library include ----------

#include "si5351jk.h"                      // 2016/10/23 JA2GQP
#include <SPI.h>
#include <EEPROM.h>
#include "Rotary.h"
#include "Ucglib.h"

/*
 * Hardware SPI Pins:
 * Arduino nano sclk=13, data=11 
*/

// I/O setting
 
  const byte __CS=10;
  const byte __DC=9;
  const byte __RST=8;

 // const byte modeout1=7;                    // 2016/10/24 JA2GQP
  const byte txout=12;                   // 
  const byte bandout1=4;                    //  The mode switch has been removed so it was possible
  const byte bandout2=5;                    //  to have 10 bands.
  const byte bandout3=6;                    //  The 4 bandout goes to a 4028
  const byte bandout4=7;                   //  2020.01.05 OZ6YK
  const byte txsw=A3;                       //  
  const byte meterin=A0;                    // 
  const byte analogsw=A1;                   // 
  

  Rotary r=Rotary(2,3);
   Ucglib_ST7735_18x128x160_HWSPI ucg(__DC, __CS, __RST);
  
 


//----------- Default Frequency Value --------------------

#define   UPPER      0                    // Upoper heterodyne
#define   LOWER      1                    // Lower heterodyne
 


//----------- Default ETC. Value --------------------

#define   DEF_STP    100L                 // Init STEP  2019.01.31 OZ6YK
#define   DEF_Mode   0                    // 0=LSB 1=USB 2=CW 3=AM

//----------  Memory Assign  ------------------


long ifshiftb;

byte Byt_Chn;                             // Channel SW   2019.01.31 OZ6YK
byte Byt_Chnb;                            //            Old
int_fast32_t timepassed;                  // int to hold the arduino miilis since startup
int Flg_eepWT = 0;                        // EEP Wite Flag 

//---------- Variable setting ----------

  long romf[4];
  long freq =7100000;
  long freqmax=30000000;
  long freqmin=1500000;
  long freqold=0;
  long freqrit=0;

  String freqt=String(freq);

  long ifshift = 0;
/*
  long ifshiftLSB =  10698500;            // RX IF Shift LSB
  long ifshiftUSB =  10701500;            //             USB
  long ifshiftCW  =  10699200;            //             CW
  long ifshiftAM  =  10700000;            //             AM
  long txshiftLSB =  10698500;            // TX IF Shift LSB
  long txshiftUSB =  10701500;            //             USB
  long txshiftCW  =  10700000;            //             CW
  long txshiftAM  = 10700000;            //             AM


  
*/
   long ifshiftLSB =7998500; // VFO>frequency USB/LSB is turn over
  long ifshiftUSB =8001500;  // the IF has been chosen because I had a lot of 8MHz x-tals
  long ifshiftCW  =7999200;
  long ifshiftAM  =8000000;  
  long txshiftLSB =7998500;
  long txshiftUSB =8001500;
  long txshiftCW  =8000000;
  long txshiftAM  =8000000;
/*
  long ifshiftLSB =8998500; // VFO>frequency USB/LSB is turn over
  long ifshiftUSB =9001500;  // the IF has been chosen because I had a lot of 8MHz x-tals
  long ifshiftCW  =8999200;
  long ifshiftAM  =9000000;  
  long txshiftLSB =8998500;
  long txshiftUSB =9001500;
  long txshiftCW  =9000000;
  long txshiftAM  =9000000;
*/
  long ddsfreq = 0;
  long ddsfreqb;           // 2016/10/23 JA2GQP
byte   hetero = UPPER;                    // Lower heterodyne set
  char f100m,f10m,fmega,f100k,f10k,f1k,f100,f10,f1;

  int ddsstep=2;
  int rit=0;
  int fstep=100;
  int steprom=1;
  int fmode=3;
  int fmodeold=1;
  int flagrit=0;
  int fritold=0;
  int flagmode=0;
  int meterval1=0;
  int tmeterval=0;
  int romadd=0;
  int analogdata=0;
  int band=0;
  int bandmax=10;  

//----------  Initialization  Program  ----------------------
 
void setup() {
 i2cInit();                             // I2c initialaz  2016/10/23 JA2GQP
  
  delay(100);
  ucg.begin(UCG_FONT_MODE_TRANSPARENT);
  ucg.clearScreen();
  ucg.setRotate270();
  pinMode (txout,OUTPUT);
  pinMode (bandout1,OUTPUT);
  pinMode (bandout2,OUTPUT);
  pinMode (bandout3,OUTPUT);
  pinMode (bandout4,OUTPUT);    //  2020.01.05 OZ6YK
  pinMode(txsw,INPUT_PULLUP);

  
  PCICR |=(1<<PCIE2);
  PCMSK2 |=(1 << PCINT18) | (1 << PCINT19);
  sei();



  band=EEPROM.read(0x01);
  romadd=0x010+(band*0x10);
  for (int i=0; i<3;i++){
   romf[i]=eepread((romadd+4*i));
  }
  freq = romf[0];
  freqmin = romf[1];
  freqmax = romf[2];
  fmode = EEPROM.read(romadd+12);
  steprom = EEPROM.read(romadd+13);
  if (steprom==1){fstep=10;}
  if (steprom==2){fstep=100;}
  if (steprom==3){fstep=1000;}
  if (steprom==4){fstep=10000;}
  banddataout();
  screen01();
  chlcd();
  if (fmode==0){fmode=3;}
  else{fmode=fmode-1;}
  modeset();
  steplcd();
  freqt=String(freq);
  freqlcd();
}

//----------  Main program  ---------------------------------
 
void loop() {

  analogdata=analogRead(analogsw);

   
    if (analogdata<50){                    
      setstep();
    } else if (analogdata<300){             
      modeset();
    } else if (analogdata<600){             
      setrit();
    }else if (analogdata<750){              
      bandcall();
    }else if (analogdata<980){              
      bandwrite();
    }
  if (digitalRead(txsw)==LOW){txset();}
  if (flagrit==1){
    if (freqrit == fritold){
      meter();
    }    
    if (freqrit!=fritold){
      ddswrite();
      ritlcd();
      fritold=freqrit;  
    }
  }
  else{
    if (freq == freqold){
        meter();
    }
  ddswrite();
  freqt=String(freq); 
  freqlcd();
  freqold=freq;
  }
}

//----------  Function DDS set  --------------- 2016/10/23  JA2GQP        

void Fnc_Dds(long frequency){
  if(ddsfreq != ddsfreqb){
    si5351aSetFrequency(frequency);
  SetPower(1);
    ddsfreqb = ddsfreq;  
  }
}
//----------  BFO out  ---------------   2020.01.05 OZ6YK
void Bfo_out(long frequency){
  if(ifshift != ifshiftb){
    si5351aSetFrequency2(frequency);
 //    SetPower(1);
    ifshiftb = ifshift;  
  }
}

//---------- meter --------------------------

void meter(){
 meterval1=analogRead(meterin);
 meterval1=meterval1/50;
 if (meterval1>15){meterval1=15;}
  int sx1=sx1+(meterval1*17);
  sx1=sx1+41;
  int sx2=0;
  sx2=sx2+(40+((15-meterval1)*17));
  ucg.setFont(ucg_font_fub11_tn);
  ucg.setColor(0,0,0);
  ucg.drawBox(sx1,100,sx2,16);
  ucg.setPrintPos(20,110);
  for(int i=1;i<=meterval1;i++){
    if (i<=9){
      ucg.setColor(0,255,255);
      ucg.print("-");  
    }
    else{
      ucg.setColor(255,0,0);
      ucg.print("-");
    }
  }
}

//---------- Encoder Interrupt -----------------------

ISR(PCINT2_vect) {
  if (flagrit==1){
  unsigned char result = r.process();
    if(result) {
      if(result == DIR_CW){  
        freqrit=freqrit+fstep;
        if (freqrit>=10000){
          freqrit=10000;
        }
     }
     else{
      freqrit=freqrit-fstep;
      if (freqrit<=-10000){
        freqrit=-10000;
      }
    }
   }
  }
  else{
    unsigned char result = r.process();
      if(result) {
        if(result == DIR_CW){  
          freq=freq+fstep;
          if (freq>=freqmax){freq=freqmax;}
        }
        else{
          freq=freq-fstep;
          if (freq<=freqmin){freq=freqmin;}
        }  
     }
  }
}

//------------ On Air -----------------------------

void txset(){
   // long vfofreq_RX = vfofreq;;
 // long ifshift_RX = ifshift;;
  noInterrupts();
    if (fmode==0){ddsfreq=freq-txshiftLSB;}  // I have chosen to change to freq minus ifshift
    if (fmode==1){ddsfreq=freq-txshiftUSB;}  // because I wanted to be able to go down til the 160m band 
    if (fmode==2){ddsfreq=freq-txshiftCW;}
    if (fmode==3){ddsfreq=freq-txshiftAM;}
ddsfreq=freq+ifshift;                       //  2020.01.05 OZ6YK

    Fnc_Dds(ddsfreq);                       // DDS out  2016/10/24 JA2GQP
    
 Fnc_Dds(ddsfreq);                           // vfo out   2020.01.05 OZ6YK
 Bfo_out(ifshift);                           // BFO out   2020.01.05 OZ6YK

//digitalWrite(txout,LOW); 
  ucg.setPrintPos(115,80);  
    ucg.setFont(ucg_font_fub11_tr);
    ucg.setColor(255,0,0);
    ucg.print("TX");
     
    while(digitalRead(txsw) == LOW){
 //     meter();
 digitalWrite(txout,HIGH);
 }
 if (digitalRead(txsw) == HIGH) {
digitalWrite(txout,LOW);
   } 
//  vfofreq = vfofreq_RX;
//  ifshift = ifshift_RX;
  
 ucg.setFont(ucg_font_fub11_tr);
    ucg.setColor(0,0,0);
   ucg.drawBox(110,68,80,20); 
    ddswrite();
   interrupts();
  }
  

  
//------------- Mode change(LSB-USB-CW-AM) ------------

void modeset(){
// ucg.setFont(ucg_font_6x10_mf);
  ucg.setFont(ucg_font_fur11_tf); 
    ucg.setPrintPos(9,50);
 
  ucg.setColor(0,128,255); 
    ucg.print("USB");
 
    ucg.setPrintPos(9,50);
    ucg.print("LSB"); 
      ucg.setPrintPos(9,50);
  
    ucg.print("A M");
 
  ucg.setPrintPos(9,50);
    ucg.print("C W");
  if (fmode==0){
    ifshift=ifshiftUSB;
    flagmode = 0;    
    ucg.setColor(255,255,0);
 
  ucg.setPrintPos(9,50);
    ucg.print("USB");

  }
  if(fmode==1){
    ifshift=ifshiftCW;
    flagmode = 1;    
   
   ucg.setPrintPos(9,50); 
    ucg.setColor(255,255,0);
    ucg.print("C W");

  }
  if (fmode==2){
    ifshift=ifshiftAM;
    flagmode = 2;    
   
  
    ucg.setPrintPos(9,50);
    ucg.setColor(255,255,0); 
    ucg.print("A M");
 
    }
  if (fmode==3){
    ifshift=ifshiftLSB;
    flagmode = 3;    

 ucg.setPrintPos(9,50);
    ucg.setColor(255,255,0);
    ucg.print("LSB");
 
  }
  fmode=fmode+1;
  if (fmode==4){fmode=0;}
  ddswrite();
  while(analogRead(analogsw) <1000);
}

//------------ Rit SET ------------------------------

void setrit(){
  if(flagrit==0){
    flagrit=1;
     ucg.setFont(ucg_font_6x10_mf);            //11ucg_font_fub11_tn
    ucg.setPrintPos(80,60);    
    ucg.setColor(255,0,0);
    ucg.print("RIT");
    ritlcd();
  }
  else {
    flagrit=0;
    ddsfreq=freq-ifshift;


    Fnc_Dds(ddsfreq);                       // DDS Out  2016/10/23 JA2GQP

    freqt=String(freq); 
     ucg.setFont(ucg_font_6x10_mf);          //11ucg_font_fub11_tn
    ucg.setPrintPos(80,60);                 //190,110
    ucg.setColor(255,255,255);
    ucg.print("RIT");
    ucg.setColor(0,0,0);  
    ucg.drawRBox(112,52,44,10,1);           //222,92,91,21,3 
    freqrit=0;
  }
  while(analogRead(analogsw) <1000);
}

//----------- Rit screen ----------------------

void ritlcd(){
  noInterrupts();
  ucg.setColor(0,0,0);  
  ucg.drawBox(111,51,45,13);              //222,92,91,21 110,50,47,15,
  ucg.setFont(ucg_font_6x10_mf);          //17 ucg_font_fub11_tn
  ucg.setColor(0,255,255); 
  ucg.setPrintPos(115,61);                //230,110
  ucg.print(freqrit);
  interrupts();
}

//-------------- encorder frequency step set -----------

void setstep(){
  noInterrupts();
  if (fstep==10000){
    fstep=10;
  }
  else{
    fstep=fstep * 10;
  } 
 steplcd(); 
 while(analogRead(analogsw) < 1000);
 interrupts();
}

//------------- Step Screen ---------------------------

void steplcd(){
  ucg.setColor(0,0,0);                    //0,0,0
  ucg.drawRBox(111,33,45,11,1);           //221,61,93,23,3
  ucg.setFont(ucg_font_6x10_mf);          //17ucg_font_fub11_tn
  ucg.setColor(255,255,255);
  ucg.setPrintPos(110,43);                //220,80
  if (fstep==10000){ucg.print("  10KHz");}
  if (fstep==1000){ucg.print("   1KHz");}
  if (fstep==100){ucg.print("  100Hz");} 
  if (fstep==10){ucg.print("  10Hz");}
}

//----------- Main frequency screen -------------------

void freqlcd(){
ucg.setFont(ucg_font_osr18_tn); //n
  int mojisuu=(freqt.length());
  if(freq<100){
    ucg.setColor(0,0,0);
   ucg.drawBox(109,6,14,19);             //217,9,28,36
    
  }
  if(f10 !=(freqt.charAt(mojisuu-2))){
    ucg.setColor(0,0,0);
    ucg.drawBox(124,6,16,19);           //245,9,28,36

    ucg.setPrintPos(125,25);
    ucg.setColor(0,255,0);
    ucg.print(freqt.charAt(mojisuu-2)); 
    f10 = (freqt.charAt(mojisuu-2));
  }
  
  if(freq<10){
    ucg.setColor(0,0,0);
  ucg.drawBox(123,6,14,19);           //245,9,28,36  
     }
  if(f1 !=(freqt.charAt(mojisuu-1))){
    ucg.setColor(0,0,0);
 //  ucg.drawBox(140,6,14,19);              //174,9,28,36  87
    ucg.setPrintPos(174,24);               //(174,45     87
;
    ucg.setColor(0,255,0);
    ucg.print(freqt.charAt(mojisuu-1));     
    f1  = (freqt.charAt(mojisuu-1));   
  }

  if(freq<1000){
    ucg.setColor(0,0,0);
    ucg.drawBox(101,6,14,19);              //   (202,9,15,36    
    }
  if(f100 !=(freqt.charAt(mojisuu-3))){
    ucg.setColor(0,0,0);
    ucg.drawBox(106,6,17,19);             //217,9,28,36
     ucg.setPrintPos(108,25);              //(215,45

    ucg.setColor(0,255,0);
    ucg.print(freqt.charAt(mojisuu-3)); 
    f100 = (freqt.charAt(mojisuu-3));
  }
  if(freq>=1000){
       ucg.setPrintPos(101,24);              //202,45
    ucg.setColor(0,255,0);
    ucg.print(".");
  }
  if(freq<10000){
    ucg.setColor(0,0,0);
     ucg.drawBox(101,6,14,19);              //146,9,28,36

    }
  if(f1k !=(freqt.charAt(mojisuu-4))){
    ucg.setColor(0,0,0);
    ucg.drawBox(88,6,14,19);              //174,9,28,36
    ucg.setPrintPos(87,25);               //(174,45

    ucg.setColor(0,255,0);
    ucg.print(freqt.charAt(mojisuu-4));       
    f1k  = (freqt.charAt(mojisuu-4));
  }
  if(freq<100000){
    ucg.setColor(0,0,0);
    ucg.drawBox(73,7,14,19);              //118,9,28,36
  }
  if(f10k !=(freqt.charAt(mojisuu-5))){
    ucg.setColor(0,0,0);
    ucg.drawBox(71,6,16,19);              //146,9,28,36
    ucg.setPrintPos(72,25);               //146,45
    ucg.setColor(0,255,0);
    ucg.print(freqt.charAt(mojisuu-5));   
    f10k = (freqt.charAt(mojisuu-5));
  }
   if(freq<1000000){
    ucg.setColor(0,0,0);
    ucg.drawBox(59,6,14,19); 
    }
  if(f100k !=(freqt.charAt(mojisuu-6))){
    ucg.setColor(0,0,0);
     ucg.drawBox(59,7,14,19);              //118,9,28,36

    ucg.setPrintPos(58,25);
    ucg.setColor(0,255,0);
    ucg.print(freqt.charAt(mojisuu-6));   
    f100k = (freqt.charAt(mojisuu-6));
  }
       
   if(freq>=1000000){
   ucg.setPrintPos(52,25);                //103,9,15,36 
    ucg.setColor(0,255,0);
    ucg.print(".");
  }
   if(freq<10000000){
     ucg.setColor(0,0,0);
    ucg.drawBox(20,6,14,19);
     }
   if(fmega !=(freqt.charAt(mojisuu-7))){
    ucg.setColor(0,0,0);
    ucg.drawBox(35,6,15,19);
    ucg .setPrintPos(37,25);
    ucg.setColor(0,255,0);
    ucg.print(freqt.charAt(mojisuu-7));   
    fmega  = (freqt.charAt(mojisuu-7));
   }
   if(freq<100000000){
    ucg.setColor(0,0,0);
    ucg.drawBox(3,6,14,19);
       }
   if (f10m !=(freqt.charAt(mojisuu-8))){
    ucg.setColor(0,0,0);
    ucg.drawBox(15,6,21,19);
    ucg .setPrintPos(20,25);
    ucg.setColor(0,255,0);
    ucg.print(freqt.charAt(mojisuu-8));
    f10m = (freqt.charAt(mojisuu-8));
   }

}
//----------- Basic Screen -------------------------

void screen01(){
  ucg.setColor(255,255,255);            //
  ucg.drawRFrame(0,0,160,28,3);         //0,0,320,55,5 OUTside
 ucg.setColor(0,0,0  );              //FILL COLOR for MODE back 
  ucg.drawRBox(1,1,159,26,1);
  
  ucg.setColor(0,128,255);              //FILL COLOR for MODE back 
  ucg.drawRBox(3,35,38,20,1);           //5,60,60,25,3  LSB

 // ucg.setFont(ucg_font_6x10_mf);        //17
  ucg.setFont(ucg_font_fur11_tf);
  ucg.setPrintPos(9,50);                //12,82

  ucg.setColor(0,128,255); 
  ucg.print("LSB");

  ucg.setPrintPos(9,50);
  ucg.print("USB");

 ucg.setPrintPos(9,50);
  ucg.print("C W");

  ucg.setPrintPos(9,50);
  ucg.print("A M"); 
  ucg.setColor(255,255,255);
  ucg.drawRFrame(110,32,47,15,1);       //220,60,95,25,3 STEP frame
  ucg.drawRFrame(110,50,47,15,1);       //220,90,95,25,3 RIT frame
  ucg.setColor(255,255,100);            //100,100,100
  ucg.setPrintPos(7,120);               //15,200
  ucg.print("S:");

  ucg.setFont(ucg_font_6x10_mf);        //11ucg_font_fub11_tn
  ucg.setColor(250,255,0);
  ucg.setPrintPos(80,43);               //175,80
  ucg.print("STEP");
  ucg.setPrintPos(80,60);               //190,110
  ucg.setColor(255,255,0);
  ucg.print("RIT");
  ucg.setColor(255,255,255);            //100,100,100
  ucg.setPrintPos(20,120);              //40,210
  ucg.print("1--3---6---9--Over---");
 

   ucg.setFont(ucg_font_osr18_tn);       //35 ucg_font_fub20_tf???
    ucg.setColor(0,255,0);

    ucg.setPrintPos(142,24);            //273,45
    ucg.print("0");                     //Frequency  end
  
    
}
//---------- DDS Frequency write -----------

void ddswrite(){
  if (flagrit==0){
    if(hetero == UPPER)
      ddsfreq=freq+ifshift;
    else
      ddsfreq=ifshift-freq;
    Fnc_Dds(ddsfreq);                               // DDS out  2016/10/24 JA2GQP
  }

  if(flagrit==1){                                  // BFO    2020.01.05 OZ6YK
    if(hetero == UPPER)
      ddsfreq=freq+ifshift-freqrit;
    else
      ddsfreq=ifshift-freqrit+freq;  
    Fnc_Dds(ddsfreq);                              // DDS out
  }
  Bfo_out(ifshift);                                // BFO    2020.01.05 OZ6YK
}


//---------- Band data call from eeprom ----------

void bandcall(){
  band=band+1;
  if (band>(bandmax-1)){band=0;}
  romadd=0x010+(band*0x010);
 for (int i=0; i<3;i++){
   romf[i]=eepread((romadd+4*i));
  }
  freq = romf[0];
  freqmin = romf[1];
  freqmax = romf[2];
  fmode = EEPROM.read(romadd+12);
  steprom = EEPROM.read(romadd+13);
  if (fmode >=1 ){
    fmode=fmode-1;
  }else if (fmode==0){
    fmode=3;
  }
  if (steprom==1){fstep=10;}
  if (steprom==2){fstep=100;}
  if (steprom==3){fstep=1000;}
  if (steprom==4){fstep=10000;}
  modeset();
  steplcd();
  freqt=String(freq);
  freqlcd();  
  banddataout();
  chlcd();
}

//---------- Band data write to eeprom ----------

void bandwrite(){
  romadd=0x010+(band*0x010);
 // for (int i=0;i<3;i++){
    eepwrite(freq,romadd);
//  }
  EEPROM.write(0x001,band);
  EEPROM.write(romadd+12,fmode);
  if (fstep==10){steprom=1;}
  if (fstep==100){steprom=2;}
  if (fstep==1000){steprom=3;}
  if (fstep==10000){steprom=4;}
  EEPROM.write(romadd+13,steprom);
  ucg.setPrintPos(110,170);
  ucg.setFont(ucg_font_fub17_tr);
  ucg.setColor(255,0,0);
  ucg.print("Complete!!");
  delay (500);
  ucg.setColor(0,0,0);
  ucg.drawBox(100,146,250,30);
  //ucg.drawBox(41,145,270,16); 
}

 //---------- EEPROM Write(4byte) subroutine ----------
 
void eepwrite(unsigned long f0,int epadd){
  for (int i=0; i<=3;i++){
  EEPROM.write(epadd+i,f0%256);
  f0=f0/256;
  }
}

//---------- EEPROM Read(4byte) subroutin ----------

unsigned long eepread(int epadd){
  unsigned long f0=0;
  for (int i=3; i >=0 ;i--){
    f0=f0*256+EEPROM.read(epadd+i);
    }
    return f0;
}

//---------- Band data output I/O ---------- 2020.01.05 OZ6YK

void banddataout(){
  digitalWrite(bandout1,LOW);
  digitalWrite(bandout2,LOW);
  digitalWrite(bandout3,LOW);
   digitalWrite(bandout4,LOW);
  if (band==0){} // 160
  if (band==1){ // 80
   digitalWrite( bandout1,HIGH); 
  }
   if (band==2){  //60
   digitalWrite(bandout2,HIGH); 
  }
  if (band==3){ // 40
   digitalWrite(bandout1,HIGH);
   digitalWrite(bandout2,HIGH); 
  }
  if (band==4){ // 30
   digitalWrite(bandout3,HIGH);
  }
  if (band==5){ // 20
   digitalWrite(bandout1,HIGH);
   digitalWrite(bandout3,HIGH); 
  }
  if (band==6){ //17
   digitalWrite(bandout2,HIGH);
   digitalWrite(bandout3,HIGH);
  }
  if (band==7){ //15
   digitalWrite(bandout1,HIGH);
   digitalWrite(bandout2,HIGH);
   digitalWrite(bandout3,HIGH);
    }
  if (band==8){ //12
    digitalWrite(bandout4,HIGH); 
    }
   if (band==9){ //10
     digitalWrite(bandout1,HIGH);
   digitalWrite(bandout4,HIGH);     
  
  }
}

//----------  Band No.(Chanel No.) write to LCD ----------2020.01.05 OZ6YK

void chlcd(){
ucg.setColor(0,0,0);
ucg.drawBox(24,75,99,20);
ucg.setFont(ucg_font_fub11_tr);
ucg.setPrintPos(25,90);
ucg.setColor(255,255,255);
//ucg.print("MHz: ");
//ucg.print(freq+1); 
if (band==0){ucg.print(" 1 -  3 MHz");}
if (band==1){ucg.print(" 3 -  5 MHz");}
if (band==2){ucg.print(" 5 -  7 MHz");}
if (band==3){ucg.print(" 7 - 10 MHz");}
if (band==4){ucg.print("10 - 14 MHz");}
if (band==5){ucg.print("14 - 18 MHz");}
if (band==6){ucg.print("18 - 21 MHz");}
if (band==7){ucg.print("21 - 24 MHz");}
if (band==8){ucg.print("24 - 28 MHz");}
if (band==9){ucg.print("28 - 30 MHz");}

}
  
